diff -up php-5.2.9/configure.in.gnusrc php-5.2.9/configure.in
--- php-5.2.9/configure.in.gnusrc	2009-02-25 15:56:50.000000000 +0100
+++ php-5.2.9/configure.in	2009-02-27 19:33:40.000000000 +0100
@@ -58,6 +58,8 @@ AC_DEFUN([PHP_EXT_DIR],[ext/$1])dnl
 AC_DEFUN([PHP_EXT_SRCDIR],[$abs_srcdir/ext/$1])dnl
 AC_DEFUN([PHP_ALWAYS_SHARED],[])dnl
 
+AC_DEFINE([_GNU_SOURCE], 1, [Define to enable GNU C Library extensions])
+
 dnl Setting up the PHP version based on the information above.
 dnl -------------------------------------------------------------------------
 
diff -up php-5.2.9/ext/interbase/interbase.c.gnusrc php-5.2.9/ext/interbase/interbase.c
--- php-5.2.9/ext/interbase/interbase.c.gnusrc	2008-12-31 12:17:38.000000000 +0100
+++ php-5.2.9/ext/interbase/interbase.c	2009-02-27 19:33:40.000000000 +0100
@@ -24,7 +24,6 @@
 #include "config.h"
 #endif
 
-#define _GNU_SOURCE
 
 #include "php.h"
 
diff -up php-5.2.9/ext/pdo_firebird/firebird_driver.c.gnusrc php-5.2.9/ext/pdo_firebird/firebird_driver.c
--- php-5.2.9/ext/pdo_firebird/firebird_driver.c.gnusrc	2008-12-31 12:17:41.000000000 +0100
+++ php-5.2.9/ext/pdo_firebird/firebird_driver.c	2009-02-27 19:33:40.000000000 +0100
@@ -22,7 +22,6 @@
 #include "config.h"
 #endif
 
-#define _GNU_SOURCE
 
 #include "php.h"
 #include "php_ini.h"
diff -up php-5.2.9/ext/standard/file.c.gnusrc php-5.2.9/ext/standard/file.c
--- php-5.2.9/ext/standard/file.c.gnusrc	2008-12-31 12:17:44.000000000 +0100
+++ php-5.2.9/ext/standard/file.c	2009-02-27 19:33:40.000000000 +0100
@@ -118,7 +118,6 @@ php_file_globals file_globals;
 
 #ifdef HAVE_FNMATCH
 #ifndef _GNU_SOURCE
-#define _GNU_SOURCE
 #endif
 #include <fnmatch.h>
 #endif
diff -up php-5.2.9/ext/zlib/zlib_fopen_wrapper.c.gnusrc php-5.2.9/ext/zlib/zlib_fopen_wrapper.c
--- php-5.2.9/ext/zlib/zlib_fopen_wrapper.c.gnusrc	2009-01-20 16:43:05.000000000 +0100
+++ php-5.2.9/ext/zlib/zlib_fopen_wrapper.c	2009-02-27 19:35:38.000000000 +0100
@@ -19,8 +19,6 @@
 
 /* $Id: zlib_fopen_wrapper.c,v 1.46.2.1.2.7 2009/01/20 15:43:05 felipe Exp $ */
 
-#define _GNU_SOURCE
-
 #include "php.h"
 #include "php_zlib.h"
 #include "fopen_wrappers.h"
diff -up php-5.2.9/main/php.h.gnusrc php-5.2.9/main/php.h
--- php-5.2.9/main/php.h.gnusrc	2008-12-31 12:17:47.000000000 +0100
+++ php-5.2.9/main/php.h	2009-02-27 19:33:40.000000000 +0100
@@ -30,6 +30,7 @@
 #define PHP_HAVE_STREAMS
 #define YYDEBUG 0
 
+#include "php_config.h"
 #include "php_version.h"
 #include "zend.h"
 #include "zend_qsort.h"
diff -up php-5.2.9/main/streams/cast.c.gnusrc php-5.2.9/main/streams/cast.c
--- php-5.2.9/main/streams/cast.c.gnusrc	2008-12-31 12:17:48.000000000 +0100
+++ php-5.2.9/main/streams/cast.c	2009-02-27 19:36:07.000000000 +0100
@@ -18,7 +18,6 @@
 
 /* $Id: cast.c,v 1.12.2.1.2.3 2008/12/31 11:17:48 sebastian Exp $ */
 
-#define _GNU_SOURCE
 #include "php.h"
 #include "php_globals.h"
 #include "php_network.h"
diff -up php-5.2.9/main/streams/memory.c.gnusrc php-5.2.9/main/streams/memory.c
--- php-5.2.9/main/streams/memory.c.gnusrc	2008-12-31 12:17:48.000000000 +0100
+++ php-5.2.9/main/streams/memory.c	2009-02-27 19:36:40.000000000 +0100
@@ -18,7 +18,6 @@
 
 /* $Id: memory.c,v 1.8.2.6.2.20 2008/12/31 11:17:48 sebastian Exp $ */
 
-#define _GNU_SOURCE
 #include "php.h"
 
 PHPAPI int php_url_decode(char *str, int len);
diff -up php-5.2.9/main/streams/streams.c.gnusrc php-5.2.9/main/streams/streams.c
--- php-5.2.9/main/streams/streams.c.gnusrc	2009-01-08 20:21:25.000000000 +0100
+++ php-5.2.9/main/streams/streams.c	2009-02-27 19:37:04.000000000 +0100
@@ -21,7 +21,6 @@
 
 /* $Id: streams.c,v 1.82.2.6.2.33 2009/01/08 19:21:25 felipe Exp $ */
 
-#define _GNU_SOURCE
 #include "php.h"
 #include "php_globals.h"
 #include "php_network.h"
diff -up php-5.2.9/Zend/zend_language_parser.c.gnusrc php-5.2.9/Zend/zend_language_parser.c
--- php-5.2.9/Zend/zend_language_parser.c.gnusrc	2009-02-25 16:39:52.000000000 +0100
+++ php-5.2.9/Zend/zend_language_parser.c	2009-02-27 19:33:40.000000000 +0100
@@ -356,6 +356,8 @@
 #include "zend_API.h"
 #include "zend_constants.h"
 
+#include <string.h>
+
 
 #define YYERROR_VERBOSE
 #define YYSTYPE znode
